From gpfsl.lang Require Export notation.

Notation "e1 < e2" := (e1+#1 ≤ e2)%E
  (at level 70) : expr_scope.

Notation Newlft := (Lit LitPoison) (only parsing).
Notation Endlft := Skip (only parsing).

Notation "'fnrec:' f xl := e" := (rec: f (BNamed "return"::xl) := e)%E
  (at level 102, f, xl at level 1, e at level 200) : expr_scope.
Notation "'fnrec:' f xl := e" := (rec: f (BNamed "return"::xl) := e)%V
  (at level 102, f, xl at level 1, e at level 200) : val_scope.
Notation "'fn:' xl := e" := (fnrec: <> xl := e)%E
  (at level 102, xl at level 1, e at level 200) : expr_scope.
Notation "'fn:' xl := e" := (fnrec: <> xl := e)%V
  (at level 102, xl at level 1, e at level 200) : val_scope.
Notation "'return:'" := "return" : expr_scope.

Notation "'letcont:' k xl := e1 'in' e2" :=
  ((Lam (@cons binder k%binder nil) e2%E) [Rec k%binder xl%binder e1%E])
  (at level 102, k, xl at level 1, e1, e2 at level 150) : expr_scope.
Notation "'withcont:' k1 ':' e1 'cont:' k2 xl := e2" :=
  ((Lam (@cons binder k1%binder nil) e1%E) [Rec k2%binder ((fun _ : eq k1%binder k2%binder => xl%binder) eq_refl) e2%E])
  (only parsing, at level 151, k1, k2, xl at level 1, e2 at level 150) : expr_scope.

Notation "'call:' f args → k" := (f (@cons expr (λ: ["_r"], k ["_r"]) args))%E
  (only parsing, at level 102, f, args, k at level 1) : expr_scope.
Notation "'letcall:' x := f args 'in' e" :=
  (letcont: "_k" [ x ] := e in call: f args → "_k")%E
  (at level 102, x, f, args at level 1, e at level 150) : expr_scope.

(* These notations unfortunately do not print.  Also, I don't think
   we would even want them to print in general.
   TODO: Introduce a Definition. *)
Notation "e1 '<-{Σ' i } '()'" := (e1 <- #i)%E
  (only parsing, at level 80) : expr_scope.
Notation "e1 '<-{Σ' i } e2" := (e1 <-{Σ i} () ;; e1+ₗ#1 <- e2)%E
  (at level 80, format "e1 <-{Σ  i }  e2") : expr_scope.
